package service

import (
	"codeword/internal/models"
	"codeword/internal/repository"
	"context"
)

type RecoverService struct {
	RecoverRepository *repository.RecoverRepository
}

func NewRecoverService(repository *repository.RecoverRepository) *RecoverService {
	return &RecoverService{
		RecoverRepository: repository,
	}
}

func (s *RecoverService) Liveness(ctx context.Context) error {

	err := s.RecoverRepository.Liveness(ctx)
	if err != nil {
		return err
	}
	return nil

}

func (s *RecoverService) Recovery(ctx context.Context, request *models.RecoveryReq) error {

	err := s.RecoverRepository.Recovery(ctx, request)
	if err != nil {
		return err
	}
	return nil

}

func (s *RecoverService) Recoverylink(ctx context.Context) error {

	err := s.RecoverRepository.Recoverylink(ctx)
	if err != nil {
		return err
	}
	return nil

}

func (s *RecoverService) Readiness(ctx context.Context) error {

	err := s.RecoverRepository.Readiness(ctx)
	if err != nil {
		return err
	}
	return nil

}
